unit Itabexpt;

interface
 
uses
  SysUtils,
  {$IFDEF VER90}
  Windows,
  {$ELSE}
  WinTypes, WinProcs,
  {$ENDIF}
  Messages, Classes, Graphics, Controls, ExptIntf,
  Itable, DB, DBTables, Dialogs, Forms,
  StdCtrls, Buttons, ExtCtrls;
{$IFDEF VER90}
{$H-}
{$ELSE}
Type ShortString = String;
{$ENDIF}
type
  TITabExptMainForm = class(TForm)
    StatusLine: TPanel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Notebook1: TNotebook;
    GroupBox1: TGroupBox;
    CancelBttn: TBitBtn;
    Rueckbttn: TBitBtn;
    VorBttn: TBitBtn;
    GroupBox2: TGroupBox;
    EdiHauptCheck: TCheckBox;
    GroupBox4: TGroupBox;
    BrwHauptCheck: TCheckBox;
    FileopenBttn: TSpeedButton;
    Label2: TLabel;
    Label8: TLabel;
    GroupBox5: TGroupBox;
    Label7: TLabel;
    Label9: TLabel;
    DirInput: TEdit;
    SpeedButton4: TSpeedButton;
    TabelleEdit: TEdit;
    GroupBox6: TGroupBox;
    LabelNebenRadio: TRadioButton;
    LabelueberRadio: TRadioButton;
    GroupBox7: TGroupBox;
    LenFestRadio: TRadioButton;
    LenVarRadio: TRadioButton;
    EdiFontLabel: TLabel;
    EdiInputFontLabel: TLabel;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    FontDialog1: TFontDialog;
    SpeedButton7: TSpeedButton;
    LboxFontLabel: TLabel;
    GroupBox8: TGroupBox;
    Image1: TImage;
    OpenDialog2: TOpenDialog;
    CodeTable: TTable;
    FrmTable: TTable;
    BrwEditCheck: TCheckBox;
    ListBox1: TListBox;
    Label1: TLabel;
    Label3: TLabel;
    ListBox2: TListBox;
    GroupBox11: TGroupBox;
    Label12: TLabel;
    SpeedButton8: TSpeedButton;
    BrwProtoEdit: TEdit;
    BrwCheck: TCheckBox;
    BrwUpdCheck: TCheckBox;
    FrmBrwUpdCheck: TCheckBox;
    Edit3: TEdit;
    SpeedButton3: TSpeedButton;
    Label6: TLabel;
    GroupBox12: TGroupBox;
    Label13: TLabel;
    SpeedButton9: TSpeedButton;
    EdiProtoEdit: TEdit;
    EdiCheck: TCheckBox;
    EdiUpdCheck: TCheckBox;
    FrmEdiUpdCheck: TCheckBox;
    Label4: TLabel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    GroupBox14: TGroupBox;
    BrwAllBtn: TSpeedButton;
    EdiAllBtn: TSpeedButton;
    ListBox3: TListBox;
    ListBox4: TListBox;
    BrwProcUpdCheck: TCheckBox;
    EdiProcUpdCheck: TCheckBox;
    UpdOldBtn: TBitBtn;
    TableDirEdit: TEdit;
    CreateButton: TSpeedButton;
    CreatCheck: TCheckBox;
    ReorgButton: TSpeedButton;
    ReorgCheck: TCheckBox;
    ExcelBttn: TSpeedButton;
    ExcelCheck: TCheckBox;
    DBaseExportBttn: TSpeedButton;
    DBasCheck: TCheckBox;
    FarbBttn: TSpeedButton;
    ColorLabel: TLabel;
    DatBttn: TSpeedButton;
    Label5: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton10: TSpeedButton;
    PrintCheck: TCheckBox;
    PxStruBttn: TSpeedButton;
    SrceTable: TITable;
    procedure FormCreate(Sender: TObject);
    Procedure Language;
    procedure ShowHint(Sender: TObject);
    procedure FileopenBttnClick(Sender: TObject);
    procedure EndeBttnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EdiCheckClick(Sender: TObject);
    procedure CancelBttnClick(Sender: TObject);
    procedure RueckbttnClick(Sender: TObject);
    procedure VorBttnClick(Sender: TObject);
    procedure EdiHauptCheckClick(Sender: TObject);
    procedure BrwHauptCheckClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TabelleEditChange(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure DirInputExit(Sender: TObject);
    procedure BrwUpdCheckClick(Sender: TObject);
    procedure BrwCheckClick(Sender: TObject);
    procedure EdiUpdCheckClick(Sender: TObject);
    procedure BrwAllBtnClick(Sender: TObject);
    procedure EdiAllBtnClick(Sender: TObject);
    procedure ListBox3Click(Sender: TObject);
    procedure ListBox4Click(Sender: TObject);
    procedure BrwProcUpdCheckClick(Sender: TObject);
    procedure EdiProcUpdCheckClick(Sender: TObject);
    procedure UpdOldBtnClick(Sender: TObject);
    procedure CreateButtonClick(Sender: TObject);
    procedure ReorgButtonClick(Sender: TObject);
    procedure ExcelBttnClick(Sender: TObject);
    procedure DBaseExportBttnClick(Sender: TObject);
    procedure FarbBttnClick(Sender: TObject);
    procedure DatBttnClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure PxStruBttnClick(Sender: TObject);
    Private
    DateiName: ShortString;
    {DrawBitmap: TBitmap;}
    OrigEdiPas, OrigEdiFrm, OrigBrwPas, OrigBrwFrm: ShortString;
    Procedure CheckButtons;
    Procedure FillListbox;
    function DoEdiFormCreation(const FormIdent: Shortstring): TForm;
    function CreateEdiSource(const UnitIdent, FormIdent: Shortstring): TMemoryStream;
    function CreateEdiForm(const FormIdent: Shortstring): TMemoryStream;
    function DoBrwFormCreation(const FormIdent: Shortstring): TForm;
    function CreateBrowserForm(const FormIdent: Shortstring): TMemoryStream;
    function CreateBrowserSource(const UnitIdent, FormIdent,
                   EdiUnitIdent, EdiFormIdent: ShortString): TMemoryStream;
    Function GetDbTyp: Byte;
  end;

{$IFDEF VER90}
{$H+}
{$ENDIF}
  TITabDialogExpert = class(TIExpert)
  public  { Methods required by Delphi to define the expert }
    function GetName: string; override;
    function GetComment: string; override;
    function GetStyle: TExpertStyle; override;
    function GetState: TExpertState; override;
    function GetIDString: string; override;
    procedure Execute; override;
    {$IFDEF VER90}
    function GetGlyph: HICON; override;
    function GetAuthor: string; override;
    function GetPage: string; override;
    {$ELSE}
    function GetGlyph: HBITMAP; override;
    {$ENDIF}
  public
  private
  end;
{$IFDEF VER90}
{$H-}
{$ENDIF}

var ItabExptMainForm: TItabExptMainForm;

implementation

Uses Proxies, IStreams, IniFiles,
     {$IFDEF VER90}
     BDE,
     {$ELSE}
     DbiTypes, DbiProcs, DbiErrs,
     {$ENDIF}
     ITexBase, ITabTool, ITabDat, ITblCons,
     ITeSEdit, ITeDEdit,
     ITeSBrow, ITeDBrow,
     ITexCode, Upd_Stru, ITab_Dir, ITab_Def,
     ToolIntf, VirtIntf, ITabColr, ITabStrk;

{$R *.DFM}
{$IFDEF VER90}
{$R ITABEXP.R32}
{$ELSE}
{$R ITABEXP.R16}
{$ENDIF}

procedure HandleException;
begin
  ToolServices.RaiseException(ReleaseException);
end;

{$IFDEF VER90}
{$H+}
{$ENDIF}
procedure ITabDialogExpert(ToolServices: TIToolServices); far;
var
  D: TITabExptMainForm;
  BtnList: TStringList;
  ISourceStream, IFormStream: TIMemoryStream;
  FormIdent, BrwIdent: string[79];
  BrwUnitIdent, BrwFileName: ShortString;
  UZahl,Code,i   : Integer;
  UStr, Dir,iStr : ShortString;
  {$IFDEF VER90}
  UnitIdent,FileName: String;
  {$ELSE}
  UnitIdent: String[79];
  FileName: TFileName;
  {$ENDIF}
  IniFile: TIniFile;
  S: ShortString;
begin
  if ToolServices = nil then Exit;
  if ToolServices.GetNewModuleName(UnitIdent, FileName) then
  begin
    D := TITabExptMainForm.Create(Application);
    try
      Inifile:= TIniFile.Create('ITABEXPT.INI');
      D.TableDirEdit.Text:= __Laufwerk;{IniFile.ReadString('EXPERT','TABLEDIR','');}
      D.BrwProtoEdit.Text:= IniFile.ReadString('EXPERT','BRWPROTO','');
      D.EdiProtoEdit.Text:= IniFile.ReadString('EXPERT','EDIPROTO','');
      D.CreatCheck.Checked:= (IniFile.ReadString('EXPERT','CREATEBTTN','1') = '1');
      D.ReorgCheck.Checked:= (IniFile.ReadString('EXPERT','REORGBTTN','1') = '1');
      D.PrintCheck.Checked:= (IniFile.ReadString('EXPERT','PRINTBTTN','1') = '1');
      D.ExcelCheck.Checked:= (IniFile.ReadString('EXPERT','EXCELBTTN','0') = '1');
      D.DBasCheck.Checked:= (IniFile.ReadString('EXPERT','DBASEBTTN','1') = '1');
      IniFile.Free;
      D.Edit1.Text:= '';
      D.Edit3.Text:= '';
      D.DirInput.Text:= '';
      if D.ShowModal = mrOK then
      begin
        IniFile:= TIniFile.Create('ITABExpt.Ini');
        {IniFile.WriteString('EXPERT','TABLEDIR',D.TableDirEdit.Text);}
        IniFile.WriteString('EXPERT','BRWPROTO',D.BrwProtoEdit.Text);
        IniFile.WriteString('EXPERT','EDIPROTO',D.EdiProtoEdit.Text);
        if D.CreatCheck.Checked then IStr:= '1' else IStr:= '0';
        IniFile.WriteString('EXPERT','CREATEBTTN',IStr);
        if D.ReorgCheck.Checked then IStr:= '1' else IStr:= '0';
        IniFile.WriteString('EXPERT','REORGBTTN',IStr);
        if D.PrintCheck.Checked then IStr:= '1' else IStr:= '0';
        IniFile.WriteString('EXPERT','PRINTBTTN',IStr);
        if D.ExcelCheck.Checked then IStr:= '1' else IStr:= '0';
        IniFile.WriteString('EXPERT','EXCELBTTN',IStr);
        if D.DBasCheck.Checked then IStr:= '1' else IStr:= '0';
        IniFile.WriteString('EXPERT','DBASEBTTN',IStr);
        IniFile.Free;
        Dir:= D.DirInput.Text;
        UnitIdent:= D.Edit1.Text;
        FormIdent:= UnitIdent + 'Dialog';
        BrwUnitIdent:= D.Edit3.Text;
        BrwIdent := BrwUnitIdent + 'Dialog';
        FileName:= Dir + UnitIdent + '.PAS';
        BrwFileName:= Dir + BrwUnitIdent + '.PAS';
        if (D.BrwCheck.Checked) or (D.BrwUpdCheck.Checked) or (D.FrmBrwUpdCheck.Checked)
        or (D.BrwProcUpdCheck.Checked) then begin
          if ((D.BrwCheck.Checked) or (D.FrmBrwUpdCheck.Checked))
          and (D.BrwProcUpdCheck.Checked = False) then
          IFormStream := TIMemoryStream.Create(D.CreateBrowserForm(BrwIdent))
          else IFormStream:= NIL;
          try
            {$IFDEF VER90}
            if IFormStream <> NIL then IFormStream.AddRef;
            {$ENDIF}
            if (D.BrwCheck.Checked) or (D.BrwUpdCheck.Checked)
            or (D.BrwProcUpdcheck.Checked) then
            ISourceStream := TIMemoryStream.Create(D.CreateBrowserSource(BrwUnitIdent, BrwIdent,
                                                                         UnitIdent, FormIdent))
            else ISourceStream:= NIL;
            try
              {$IFDEF VER90}
              if ISourceStream <> NIL then ISourceStream.AddRef;
              {$ENDIF}
              ToolServices.CreateModule(BrwFileName, ISourceStream, IFormStream,
                [cmAddToProject, cmShowSource, cmShowForm, cmUnNamed,
                cmMarkModified]);
              ToolServices.SaveFile(BrwFileName);
              ToolServices.CloseFile(BrwFileName);
              ToolServices.OpenFile(BrwFileName);
            finally
              if ISourceStream <> NIL then begin
                ISourceStream.OwnStream := True;
                ISourceStream.Free;
              end;
            end;
          finally
            if IFormStream <> NIL then begin
              IFormStream.OwnStream := True;
              IFormStream.Free;
            end;
          end;
        end;
        if (D.EdiCheck.Checked) or (D.EdiUpdCheck.Checked) or (D.FrmEdiUpdCheck.Checked)
        or (D.EdiProcUpdCheck.Checked) then begin
          if (D.EdiCheck.Checked) or (D.FrmEdiUpdCheck.Checked)
          and (D.EdiProcUpdCheck.Checked = False) then
          IFormStream := TIMemoryStream.Create(D.CreateEdiForm(FormIdent))
          else IFormStream:= NIL;
          try
            {$IFDEF VER90}
            if IFormStream <> NIL then IFormStream.AddRef;
            {$ENDIF}
            if (D.EdiCheck.Checked) or (D.EdiUpdCheck.Checked)
            or (D.EdiProcUpdcheck.Checked) then
            ISourceStream := TIMemoryStream.Create(D.CreateEdiSource(UnitIdent, FormIdent))
            else ISourceStream:= NIL;
            try
              {$IFDEF VER90}
              if ISourceStream <> NIL then ISourceStream.AddRef;
              {$ENDIF}
              ToolServices.CreateModule(FileName, ISourceStream, IFormStream,
                [cmAddToProject, cmShowSource, cmShowForm, cmUnNamed,
                cmMarkModified]);
              ToolServices.SaveFile(FileName);
              ToolServices.CloseFile(FileName);
              ToolServices.OpenFile(FileName);
            finally
              if ISourceStream <> NIL then begin
                ISourceStream.OwnStream := True;
                ISourceStream.Free;
              end;
            end;
          finally
            if IFormStream <> NIL then begin
              IFormStream.OwnStream := True;
              IFormStream.Free;
            end;
          end;
        end;
      end;
    finally
      D.Free;
    end;
  end;
end;

{ TItabDialogExpert }
function TItabDialogExpert.GetName: string;
begin
  try
    Result := 'ITABExpert';
  except
    HandleException;
  end;
end;

function TItabDialogExpert.GetComment: string;
begin
  try
    Result := 'ITAB-Dialogexperte';
  except
    HandleException;
  end;
end;

{$IFDEF VER90}
function TItabDialogExpert.GetGlyph: HICON;
begin
  try
    Result := LoadIcon(HInstance, 'IT_EXPT');
  except
    HandleException;
  end;
end;

function TItabDialogExpert.GetAuthor: string;
begin
  try
    Result := 'N.Stellberg, K.Bertram';
  except
    HandleException;
  end;
end;

function TItabDialogExpert.GetPage: string;
begin
  try
    Result := 'Dialoge';
  except
    HandleException;
  end;
end;
{$ELSE}
function TItabDialogExpert.GetGlyph: HBITMAP;
begin
  try
    Result := LoadBitmap(HInstance, 'IT_EXPT');
  except
    HandleException;
  end;
end;
{$ENDIF}

function TItabDialogExpert.GetStyle: TExpertStyle;
begin
  try
    Result := esForm;
  except
    HandleException;
  end;
end;

function TItabDialogExpert.GetState: TExpertState;
begin
  try
    Result := [esEnabled];
  except
    HandleException;
  end;
end;

function TItabDialogExpert.GetIDString: string;
begin
  try
    Result := 'ITABExpert';
  except
    HandleException;
  end;
end;

procedure TItabDialogExpert.Execute;
begin
  try
    ITabDialogExpert(ToolServices);
  except
    HandleException;
  end;
end;

Type
    Structure_GetProc = Procedure(FNummer: Integer;
                                 var Fld: FldDesc;
                                 var Idx: IdxDesc;
                                 var fldCount: Byte;
                                 var idxCount: Byte); 

Function Table_Exists(Table: TTable): Boolean;
var T: ShortString;
begin
  T:= Table.DataBaseName+'\'+Table.TableName;
  While pos('\\',T) > 0 do Delete(T,Pos('\\',T),1);
  Result:= FileExists(T);
end;

Procedure GetDescs(SCount,ICount: Integer;
                   FldList: PFieldDescList;
                   IdxList: PIndexDescList;
                   var TblDesc: CrTblDesc;
                   StruGet: Structure_GetProc);
var i: Integer;
    s,ix: Byte;
    Fld: FldDesc;
    idx: IdxDesc;
begin
  if SCount > 0 then begin
    For i:= 1 to SCount do begin
      StruGet(i,Fld,idx,S,ix);
      FldList^[i-1]:= Fld;
    end;
    TblDesc.pFldDesc:= @FldList^;
    TblDesc.IFldCount:= SCount;
  end
  else begin
    TblDesc.pFldDesc:= NIL;
    TblDesc.iFldCount:= 0;
  end;
  if ICount > 0 then begin
    For i:= 1 to ICount do begin
      StruGet(-i,Fld,Idx,s,ix);
      IdxList^[i-1]:= Idx;
    end;
    TblDesc.pIdxDesc:= @IdxList^;
    TblDesc.iIdxCount:= ICount;
  end
  else begin
    TblDesc.pIdxDesc:= NIL;
    TblDesc.iIdxCount:= 0;
  end;
end;

Function Erzeuge_Tabelle(aParent  : TForm;
                         Pfad     : ShortString;
                         FileName : ShortString;
                         StruGet  : Structure_GetProc): Boolean;
var TblDesc: CrTblDesc;
    Rslt   : DBIResult;
    ErrMsg : Array[0..255] of Char;
    phdb: hDBIDb;
    pszDir: Pchar;
    SCount,iCount: Byte;
    FldList: PFieldDescList;
    IdxList: PIndexDescList;
    Fld    : FldDesc;
    idx    : IdxDesc;
begin
    AParent.Cursor:= crHourGlass;
    FillChar(TblDesc, SizeOf(TblDesc), 0);
    StruGet(0,Fld,Idx,SCount,ICount);
    if SCount > 0 then FldList:= AllocMem(SCount * Sizeof(FldDesc));
    if ICount > 0 then IdxList:= AllocMem(ICount * Sizeof(IdxDesc));
    GetDescs(SCount,iCount,FldList,IdxList,TblDesc,StruGet);
    StrPCopy(TblDesc.szTblName,FileName);
    rslt := DbiOpenDatabase(nil, nil, dbiREADWRITE,
                            dbiOPENSHARED, nil, 0, nil, nil,
                            phDb);
    if (Rslt = DBIErr_None) then begin
      GetMem(pszDir,255);
      if Pfad = '' then Pfad:= ExtractFilePath(Application.ExeName);
      StrPCopy(pszDir,Pfad);
      Rslt:= DbiSetDirectory(phDb,pszDir);
      FreeMem(pszDir,255);
    end;
    if Rslt = DBIErr_None then Rslt:= DbiCreateTable(phDb,True,TblDesc);
    if Rslt <> DBIErr_None then begin
      DbiGetErrorString (rslt,ErrMsg);
      Errorwindow(StrPas(ErrMsg),'');
    end;
    Result:= (RsLt = DBIErr_None);
    if SCount > 0 then FreeMem(fldList,SCount * Sizeof(FldDesc));
    if ICount > 0 then FreeMem(idxList,ICount * Sizeof(IdxDesc));
    rslt:= DbiCloseDatabase(phDb);
end;

Function Check_Tabelle(aParent: TForm; Alias: ShortString; Table: TTable; StruGet: Structure_GetProc;
         Meldung: Boolean): Boolean;
var Klar        : Boolean;
    Pfad,TblName: ShortString;
    i: Integer;
    Erzeugen: Boolean;
begin
  Klar:= False;
  TblName:= Table.TableName;
  if Alias = '' then Errorwindow('CHECK_TABELLE',GetMess(164))
  else begin
    Klar:= Table_Exists(Table);
    if Klar = False then begin
      if Meldung = False then Erzeugen:= True
      else Erzeugen:= (MessageDlg(GetMess(135)+' '+TblName+' '+GetMess(127)
           +'! '+GetMess(123), mtError, [mbYes, mbNo], 0) = mrYes);
      if Erzeugen then begin
        Klar:= Erzeuge_Tabelle(aParent,Alias,TblName,StruGet);
      end;
    end;
  end;
  Result:= Klar;
end;

{$IFDEF VER90}
{$H-}
{$ENDIF}
procedure TITabExptMainForm.FormCreate(Sender: TObject);
Var DP: ShortString;
begin
  Application.OnHint := ShowHint;
  Language;
  DP:= ExtractFilePath(Application.ExeName);
  DP:= DP + '\';
  While pos('\\',DP) > 0 do delete(DP,Pos('\\',DP),1);
  CodeTable.DataBaseName:= DP;
  {$IFNDEF VER90}
  if Check_Tabelle(Self,DP,CodeTable,Upd_Struktur,False) = False
  then MessageDlg(GetMess(165), mtError, [mbOk], 0)
  else CodeTable.Active:= True;
  {$ELSE}
  CodeTable.SessionName:= 'Default';
  CodeTable.DatabaseName:= DP;
  CodeTable.TableName:= 'ITABEDIT.DB';
  if not(Table_Exists(CodeTable)) then with CodeTable do begin
    Active := False;
    TableName:= 'ITABEDIT.DB';
    DatabaseName := DP;
    TableType := ttParadox;
    with FieldDefs do begin
      Clear;
      Add('RecNo', ftAutoInc, 0, false);
      Add('Bereich', Db.ftInteger, 0, false);
      Add('Reihe',db.ftInteger,0,false);
      Add('Name',db.ftString,30,false);
      Add('Source',db.ftMemo,100,false);
    end;
    with IndexDefs do begin
      Clear;
      Add('','RecNo',[ixPrimary, ixUnique]);
      Add('BName', 'Bereich;Name', [ixCaseInsensitive]);
      Add('BReihe','Reihe',[ixCaseInsensitive]);
    end;
    CreateTable;
  end;
  CodeTable.Active:= True;
  {$ENDIF}
  FrmTable.DataBaseName:= DP;
  {$IFNDEF VER90}
  if Check_Tabelle(Self,DP,FrmTable,WNT_FORM_PDXStruktur,False) = False
  then MessageDlg(GetMess(166), mtError, [mbOk], 0)
  else FrmTable.Active:= True;
  {$ELSE}
  FrmTable.SessionName:= 'Default';
  FrmTable.DatabaseName:= DP;
  FrmTable.TableName:= 'ITABFORM.DB';
  if not(Table_Exists(FrmTable)) then with FrmTable do begin
    Active := False;
    TableName:= 'ITABFORM.DB';
    DatabaseName := DP;
    TableType := ttParadox;
    with FieldDefs do begin
      Clear;
      Add('RecNo', ftAutoInc, 0, false);
      Add('Reihe',db.ftInteger,0,false);
      Add('Name',db.ftString,255,false);
      Add('Source',db.ftMemo,100,false);
    end;
    with IndexDefs do begin
      Clear;
      Add('','RecNo',[ixPrimary, ixUnique]);
      Add('BName', 'Name', [ixCaseInsensitive]);
      Add('BReihe','Reihe',[ixCaseInsensitive]);
    end;
    CreateTable;
  end;
  FrmTable.Active:= True;
  {$ENDIF}
  DateiName:= '';
  CheckButtons;
  OrigEdiPas:= '';
  OrigEdiFrm:= '';
  OrigBrwPas:= '';
  OrigBrwFrm:= '';
end;

Procedure TITabExptMainForm.Language;
begin
  Groupbox1.Caption:= GetMess(133);
  Groupbox5.Caption:= GetMess(143);
  Groupbox6.Caption:= GetMess(154);
  Groupbox7.Caption:= GetMess(155);
  Groupbox8.Caption:= GetMess(153);
  Groupbox14.Caption:= GetMess(162);
  Label1.Caption:= GetMess(136);
  Label2.Caption:= GetMess(135);
  Label3.Caption:= GetMess(137);
  Label4.Caption:= GetMess(146);
  Label6.Caption:= GetMess(146);
  Label8.Caption:= GetMess(134);
  Label9.Caption:= GetMess(144);
  CancelBttn.Caption:= GetMess(102);
  CancelBttn.Hint:= GetMess(102);
  RueckBttn.Caption:= GetMess(138);
  RueckBttn.Hint:= GetMess(138);
  VorBttn.Caption:= GetMess(139);
  VorBttn.Hint:= GetMess(139);
  DatBttn.Hint:= GetMess(134);
  FileOpenBttn.Hint:= GetMess(140);
  SpeedButton1.Hint:= GetMess(147);
  SpeedButton2.Hint:= GetMess(141);
  UpdOldBtn.Hint:= GetMess(142);
  SpeedButton3.Hint:= GetMess(147);
  SpeedButton4.Hint:= GetMess(145);
  SpeedButton5.Hint:= GetMess(160);
  SpeedButton6.Hint:= GetMess(161);
  SpeedButton8.Hint:= GetMess(148);
  BrwAllBtn.Hint:= GetMess(163);
  EdiAllBtn.Hint:= GetMess(163);
  BrwCheck.Caption:= GetMess(149);
  EdiCheck.Caption:= GetMess(149);
  BrwHauptcheck.Caption:= GetMess(150);
  BrwEditCheck.Caption:= GetMess(151);
  EdiHauptCheck.Caption:= GetMess(152);
  LenVarRadio.Caption:= GetMess(156);
  LenFestRadio.Caption:= GetMess(157);
  LabelNebenRadio.Caption:= GetMess(158);
  LabelUeberRadio.Caption:= GetMess(159);
end;

procedure TITabExptMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.Caption := Application.Hint;
end;

Procedure TITabExptMainForm.CheckButtons;
var i: Integer;
    Dir: ShortString;
begin
  i:= Notebook1.PageIndex;
  RueckBttn.Enabled:= I > 0;
  if I = 3 then UpdOldBtn.Visible:= True
  else UpdOldBtn.Visible:= False;
  if I = 0 then VorBttn.Enabled:= (DateiName <> '')
  else if I = 3 then VorBttn.Enabled:= (BrwProtoEdit.Text <> '') and (EdiProtoEdit.Text <> '')
  else if I = 4 then VorBttn.Enabled:= ((BrwProcUpdCheck.Checked) and (Listbox3.Selcount > 0))
                                    or ((EdiProcUpdCheck.checked) and (Listbox4.SelCount > 0))
  else
    VorBttn.Enabled:= ((DirInput.Text <> '') and
      ((Edit1.Text <> '') or (Edit3.Text <> '')));
  if VorBttn.Enabled then begin
    if ((I = 4) or ((I = 3) and (BrwUpdCheck.Checked = False) and
          (EdiUpdCheck.Checked = False))) then VorBttn.Caption:= GetMess(149)
    else VorBttn.Caption:= GetMess(139);
    if I = 3 then FillListBox;
  end;
  if I = 1 then begin
    Dir:= DirInput.Text;
    While Copy(Dir,Length(Dir),1) = '\' do Dir:= Copy(Dir,1,Length(Dir)-1);
    if (Edit1.Text <> '') then begin
      OrigEdiPas:= Dir + '\'+Edit1.Text+'.PAS';
      OrigEdiFrm:= Dir + '\'+Edit1.Text+'.DFM';
      if FileExists(OrigEdiPas) = False then begin
        EdiUpdCheck.Checked:= False;
        EdiUpdCheck.Enabled:= False;
      end
      else begin
        EdiUpdCheck.Enabled:= True;
      end;
      if FileExists(OrigEdiFrm) = False then begin
        FrmEdiUpdCheck.Checked:= False;
        FrmEdiUpdCheck.Enabled:= False;
      end
      else begin
        FrmEdiUpdCheck.Enabled:= True;
      end;
    end;
    if (Edit3.Text <> '') then begin
      OrigBrwPas:= Dir + '\'+Edit3.Text+'.PAS';
      OrigBrwFrm:= Dir + '\'+Edit3.Text+'.DFM';
      if FileExists(OrigBrwPas) = False then begin
        BrwUpdCheck.Checked:= False;
        BrwUpdCheck.Enabled:= False;
      end
      else begin
        BrwUpdCheck.Enabled:= True;
      end;
      if FileExists(OrigBrwFrm) = False then begin
        FrmBrwUpdCheck.Checked:= False;
        FrmBrwUpdCheck.Enabled:= False;
      end
      else begin
        FrmBrwUpdCheck.Enabled:= True;
      end;
    end;
  end;
  UpdOldBtn.Enabled:= (EdiUpdCheck.Enabled) or (BrwUpdcheck.Enabled);
  if I = 4 then begin
    BrwProcUpdcheck.Enabled:= BrwUpdCheck.Enabled;
    BrwAllBtn.Enabled:= BrwUpdCheck.Enabled;
    EdiProcUpdcheck.Enabled:= EdiUpdcheck.Enabled;
    EdiAllBtn.Enabled:= EdiUpdcheck.Enabled;
  end;
end;

Procedure TITabExptMainForm.FillListbox;
var S,BProto,EProto: ShortString;
    BP,EP: TStringList;
    i: Integer;
    Impl: Boolean;
begin
  BProto:= BrwProtoEdit.Text;
  EProto:= EdiProtoEdit.Text;
  BP:= TStringList.Create;
  BP.LoadFromFile(BProto);
  Listbox3.Clear;
  if BP.Count > 0 then begin
    Impl:= False;
    for i:= 0 to BP.Count-1 do begin
      S:= BP[i];
      S:= UpperCase(S);
      if Pos('IMPLEMENTATION',S) > 0 then Impl:= true;
      if Pos('END.',S) > 0 then Impl:= False;
      if Impl then begin
        if (Pos('PROCEDURE',S) > 0) or (Pos('FUNCTION',S) > 0) then begin
          Listbox3.Items.Add(GetProcName(S));
        end;
      end;
    end;
  end;
  BP.Free;
  EP:= TStringList.Create;
  EP.LoadFromFile(EProto);
  Listbox4.Clear;
  if EP.Count > 0 then begin
    Impl:= False;
    for i:= 0 to EP.Count-1 do begin
      S:= EP[i];
      S:= UpperCase(S);
      if Pos('IMPLEMENTATION',S) > 0 then Impl:= true;
      if Pos('END.',S) > 0 then Impl:= False;
      if Impl then begin
        if (Pos('PROCEDURE',S) > 0) or (Pos('FUNCTION',S) > 0) then
        Listbox4.Items.Add(GetProcName(S));
      end;
    end;
  end;
  EP.Free;
end;

procedure TITabExptMainForm.FileopenBttnClick(Sender: TObject);
var DatNam,Dir,TDir: ShortString;
    Klar, LoadTyp  : Boolean;
begin
  Dir:= TableDirEdit.Text+'\';
  While Pos('\\',Dir) > 0 do Delete(Dir,Pos('\\',DIR),1);
  OpenDialog1.InitialDir:= Dir;
  if OpenDialog1.Execute then begin
    DateiName:= OpenDialog1.FileName;
    DatNam:= ExtractFileName(DateiName);
    if Pos('.',DatNam) > 0 then DatNam:= Copy(DatNam,1,Pos('.',DatNam)-1);
    TDir:= ExtractFilePath(DateiName) + '\';
    While (Pos('\\',TDir) > 0) do Delete(TDir,Pos('\\',TDir),1);
    if srceTable.Active then srceTable.Close;
    if srceTable.TablePath <> __Laufwerk then srceTable.TablePath:= __Laufwerk;
    if (not FileExists(Dir+DatNam+'.DEF')) then Begin
      LoadTyp:= False;
      if FileExists(TDir+DatNam+'.TYP') then LoadTyp:= True;
      ITabDefDlg:= TITabDefDlg.Create(Self);
      try
        While Pos('\',DateiName) > 0 do Delete(DateiName,1,Pos('\',DateiName));
        if Pos('.',DateiName) > 0 then DateiName:= Copy(DateiName,1,Pos('.',DateiName)-1);
        ITabDefDlg.TblName:= DateiName;
        if LoadTyp then ITabDefDlg.Lade(TDir+DatNam+'.TYP');
        if ITabDefDlg.ShowModal = idOK then Klar:= True
        else Klar:= False;
      finally
        ITabDefDlg.Free;
      end;
    end
    else Klar:= True;
    if Klar = False then begin
      DateiName:= '';
      DatNam:= '';
      CheckButtons;
      Exit;
    end
    else begin
      SrceTable.TablePath:= Dir;
      srceTable.TableName:= DatNam;
      srceTable.Structure:= DatNam+'.DEF';
      if not FileExists(Dir+DatNam+'.DAT') then begin
        if JaNein(Dir+DatNam+'.DAT',GetMess(123))
        then srceTable.NewIsamTable(False)
        else Exit;
      end;
    end;
    srceTable.TableName:= DatNam;
    srceTable.Open;
    TabelleEdit.Text:= DatNam;
    Listbox1.Items.Clear;
    Listbox2.Items.Clear;
    srceTable.GetFieldNames(Listbox1.Items);
    srceTable.GetIndexList(Listbox2.Items);
    DatNam:= ExtractFileName(DateiName);
    DatNam:= Copy(DatNam,1,4);
    if Pos('.',DatNam) > 0 then DatNam:= Copy(DatNam,1,Pos('.',DatNam)-1);
    Edit1.Text:= DatNam + 'ITED';
    Edit3.Text:= DatNam + 'ITBR';
    DirInput.Text:= ExtractFilePath(DateiName);
  end
  else begin
    DateiName:= '';
    if srceTable.Active then srceTable.Close;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.EndeBttnClick(Sender: TObject);
begin
  Close;
end;

procedure TITabExptMainForm.FormDestroy(Sender: TObject);
begin
  if srceTable.Active then srceTable.Close;
  if FrmTable.Active then FrmTable.Close;
  if CodeTable.Active then CodeTable.Close;
  {DrawBitmap.Free;}
end;

function TITabExptMainForm.DoEdiFormCreation(const FormIdent: Shortstring): TForm;
begin
  if FrmEdiUpdCheck.Checked = False then OrigEdiFrm:= '';
  DoEdiFormCreation:= Erzeuge_EditorForm(FormIdent,srceTable,
                                      LabelNebenRadio.Checked,
                                      LenFestRadio.Checked,
                                      EdiFontLabel.Font,
                                      EdiInputFontLabel.Font,
                                      False);
end;

function TITabExptMainForm.CreateEdiSource(const UnitIdent, FormIdent: Shortstring): TMemoryStream;
begin
  if (EdiUpdCheck.Checked = False) and (EdiProcUpdCheck.checked = False) then OrigEdiPas:= '';
  CreateEdiSource:= Erzeuge_EditorSource(Self,
                                      UnitIdent, FormIdent, 
                                      EdiProtoEdit.Text,
                                      srceTable, CodeTable,
                                      EdiHauptCheck.Checked,
                                      False,
                                      OrigEdiPas);
end;
 
function TITabExptMainForm.CreateEdiForm(const FormIdent: Shortstring): TMemoryStream;
var DlgForm: TForm;
begin
  Result := nil;
  DlgForm := DoEdiFormCreation(FormIdent);
  try
    Result := TMemoryStream.Create;
    Result.WriteComponentRes(FormIdent, DlgForm);
    if OrigEdiFrm <> '' then AltForm_Verwerten(Result, OrigEdiFrm, FrmTable);
    Result.Position := 0;
  finally
    DlgForm.Free;
  end;
end;

function TITabExptMainForm.DoBrwFormCreation(const FormIdent: Shortstring): TForm;
begin
  if FrmBrwUpdCheck.Checked = False then OrigBrwFrm:= '';
  DoBrwFormCreation:= Erzeuge_BrowserForm(FormIdent,
                                          srceTable,
                                          ReorgCheck.Checked,
                                          CreatCheck.Checked,
                                          ExcelCheck.Checked,
                                          DBasCheck.Checked,
                                          PrintCheck.Checked,
                                          ((EdiCheck.Checked) or (EdiUpdCheck.Checked) or (FrmEdiUpdCheck.Checked)),
                                          BrwEditCheck.Checked,
                                          LboxFontLabel.Font,
                                          ColorLabel.Color);
end;

function TITabExptMainForm.CreateBrowserForm(const FormIdent: Shortstring): TMemoryStream;
var DlgForm: TForm;
begin
  Result := nil;
  DlgForm := DoBrwFormCreation(FormIdent);
  try
    Result := TMemoryStream.Create;
    Result.WriteComponentRes(FormIdent, DlgForm);
    if OrigBrwFrm <> '' then AltForm_Verwerten(Result, OrigBrwFrm, FrmTable);
    Result.Position := 0;
  finally
    DlgForm.Free;
  end;
end;

Function TITabExptMainForm.GetDbTyp: Byte;
var d: Byte;
    Txt: ShortString;
begin
  Txt:= ExtractFileExt(TabelleEdit.Text);
  Result:= d;
end;

function TITabExptMainForm.CreateBrowserSource(const UnitIdent, FormIdent,
  EdiUnitIdent, EdiFormIdent: Shortstring): TMemoryStream;
begin
  if (FrmBrwUpdCheck.Checked) and (BrwUpdCheck.Checked = False)
  and (BrwProcUpdCheck.checked = False) then begin
    Result:= TMemoryStream.Create;
    Try
      Result.LoadFromFile(OrigBrwPas);
    Except
      Result.Free;
      Raise;
    end;
  end
  else begin
    if (BrwUpdCheck.Checked = False) and (BrwProcUpdCheck.checked = False) then OrigBrwPas:= '';
    CreateBrowserSource:= Erzeuge_BrowserSource(Self,
                                     UnitIdent, FormIdent,
                                     EdiUnitIdent, EdiFormIdent,
                                     BrwProtoEdit.Text,
                                     srceTable, CodeTable,
                                     BrwHauptCheck.Checked,
                                     False,
                                     CreatCheck.Checked,
                                     ReorgCheck.Checked,
                                     ExcelCheck.Checked,
                                     DBasCheck.Checked,
                                     PrintCheck.Checked,
                                     ((EdiCheck.Checked) or (EdiUpdCheck.Checked) or (FrmEdiUpdCheck.Checked)),
                                     OrigBrwPas);
  end;
end;

procedure TITabExptMainForm.EdiCheckClick(Sender: TObject);
begin
  if EdiCheck.Checked then begin
    FrmEdiUpdCheck.Checked:= False;
    EdiUpdCheck.Checked:= False;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.CancelBttnClick(Sender: TObject);
begin
  ModalResult:= mrCancel;
end;

procedure TITabExptMainForm.RueckbttnClick(Sender: TObject);
var i: Integer;
begin
  i:= Notebook1.PageIndex;
  if i > 0 then Dec(i);
  if i = 3 then begin
    BrwProcUpdCheck.Checked:= False;
    EdiProcUpdCheck.Checked:= False;
  end;
  Notebook1.PageIndex:= i;
  CheckButtons;
end;

procedure TITabExptMainForm.VorBttnClick(Sender: TObject);
var i: Integer;
begin
  i:= Notebook1.PageIndex;
  if i < 3 then Inc(i)
  else ModalResult:= mrOk;
  Notebook1.PageIndex:= i;
  CheckButtons;
end;
  
procedure TITabExptMainForm.EdiHauptCheckClick(Sender: TObject);
begin
  if EdiHauptCheck.Checked then BrwHauptCheck.Checked:= False;
end;

procedure TITabExptMainForm.BrwHauptCheckClick(Sender: TObject);
begin
  if BrwHauptCheck.Checked then EdiHauptCheck.Checked:= False;
end;

procedure TITabExptMainForm.SpeedButton1Click(Sender: TObject);
var Txt: ShortString;
begin
  if SaveDialog1.Execute then begin
    Txt:= SaveDialog1.FileName;
    While Pos('\',Txt) > 0 do Delete(Txt,1,Pos('\',Txt));
    if Pos('.',Txt) > 0 then Txt:= Copy(Txt,1,Pos('.',Txt)-1);
    Edit1.Text:= Txt;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.SpeedButton3Click(Sender: TObject);
var Txt: ShortString;
begin
  if SaveDialog1.Execute then begin
    Txt:= SaveDialog1.FileName;
    While Pos('\',Txt) > 0 do Delete(Txt,1,Pos('\',Txt));
    if Pos('.',Txt) > 0 then Txt:= Copy(Txt,1,Pos('.',Txt)-1);
    Edit3.Text:= Txt;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.SpeedButton4Click(Sender: TObject);
begin
  DirDlg:= TDirDlg.Create(Self);
  Try
    if DirDlg.ShowModal = mrOk then
    DirInput.Text:= DirDlg.DirectoryListbox1.Directory+'\';
  Finally
    DirDlg.Free;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.SpeedButton5Click(Sender: TObject);
begin
  if FontDialog1.Execute then EdiFontLabel.Font:= FontDialog1.Font;
end;

procedure TITabExptMainForm.SpeedButton6Click(Sender: TObject);
begin
  if FontDialog1.Execute then EdiInputFontLabel.Font:= FontDialog1.Font;
end;

procedure TITabExptMainForm.SpeedButton7Click(Sender: TObject);
Begin
  if FontDialog1.Execute then LboxFontLabel.Font:= FontDialog1.Font;
end;

procedure TITabExptMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TITabExptMainForm.TabelleEditChange(Sender: TObject);
var Txt: ShortString;
begin
  Txt:= TabelleEdit.Text;
  if Txt <> '' then Txt:= ExtractFileExt(Txt);
end;

procedure TITabExptMainForm.SpeedButton8Click(Sender: TObject);
begin
  OpenDialog2.Title:= 'Browser-Prototyp';
  if OpenDialog2.Execute then BrwProtoEdit.Text:= OpenDialog2.FileName;
  CheckButtons;
end;

procedure TITabExptMainForm.SpeedButton9Click(Sender: TObject);
begin
  OpenDialog2.Title:= 'Editor-Prototyp';
  if OpenDialog2.Execute then EdiProtoEdit.Text:= OpenDialog2.FileName;
  CheckButtons;
end;

procedure TITabExptMainForm.DirInputExit(Sender: TObject);
begin
  CheckButtons;
end;

procedure TITabExptMainForm.BrwUpdCheckClick(Sender: TObject);
begin
  if (BrwUpdCheck.Checked) or (FrmBrwUpdCheck.Checked) then begin
    BrwCheck.Checked:= False;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.BrwCheckClick(Sender: TObject);
begin
  if BrwCheck.Checked then begin
    FrmBrwUpdCheck.Checked:= False;
    BrwUpdCheck.Checked:= False;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.EdiUpdCheckClick(Sender: TObject);
begin
  if (EdiUpdCheck.Checked) or (FrmEdiUpdCheck.Checked) then begin
    EdiCheck.Checked:= False;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.BrwAllBtnClick(Sender: TObject);
var i: Integer;
begin
  if Listbox3.Items.Count > 0 then begin
    For i:= 0 to Listbox3.Items.Count-1 do begin
      Listbox3.Selected[i]:= True;
    end;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.EdiAllBtnClick(Sender: TObject);
var i: Integer;
begin
  if Listbox4.Items.Count > 0 then begin
    For i:= 0 to Listbox4.Items.Count-1 do begin
      Listbox4.Selected[i]:= True;
    end;
  end;
  CheckButtons;
end;

procedure TITabExptMainForm.ListBox3Click(Sender: TObject);
begin
  CheckButtons;
end;

procedure TITabExptMainForm.ListBox4Click(Sender: TObject);
begin
  ChecKButtons;
end;

procedure TITabExptMainForm.BrwProcUpdCheckClick(Sender: TObject);
begin
  CheckButtons;
end;

procedure TITabExptMainForm.EdiProcUpdCheckClick(Sender: TObject);
begin
  CheckButtons;
end;

procedure TITabExptMainForm.UpdOldBtnClick(Sender: TObject);
begin
  Notebook1.PageIndex:= 4;
  CheckButtons;
end;

procedure TITabExptMainForm.CreateButtonClick(Sender: TObject);
begin
  CreatCheck.Checked:= Not(CreatCheck.Checked);
end;

procedure TITabExptMainForm.ReorgButtonClick(Sender: TObject);
begin
  ReorgCheck.Checked:= not(ReorgCheck.Checked);
end;

procedure TITabExptMainForm.ExcelBttnClick(Sender: TObject);
begin
  ExcelCheck.Checked:= not(ExcelCheck.Checked);
end;

procedure TITabExptMainForm.DBaseExportBttnClick(Sender: TObject);
begin
  DBasCheck.Checked:= not(DBasCheck.Checked);
end;

procedure TITabExptMainForm.FarbBttnClick(Sender: TObject);
begin
  ITabColorDlg:= TItabColorDlg.Create(Self);
  Try
    if ColorLabel.Color = clBackground then ITabColorDlg.R2.Checked:= True
    else if ColorLabel.Color = clWhite then ITabColorDlg.R3.Checked:= True
    else if ColorLabel.Color = clBtnFace then ITabColorDlg.R4.Checked:= True
    else if ColorLabel.Color = clBtnShadow then ITabColorDlg.R5.Checked:= True
    else if ColorLabel.Color = clBtnHighlight then ITabColorDlg.R6.Checked:= True
    else if ColorLabel.Color = clScrollbar then ITabColorDlg.R7.Checked:= True
    else ITabColorDlg.R1.Checked:= True;
    if ITabColorDlg.ShowModal = mrOk then begin
      if ITabColorDlg.R1.Checked then ColorLabel.Color:= clWindow
      else if ITabColorDlg.R2.Checked then ColorLabel.Color:= clBackground
      else if ITabColorDlg.R3.Checked then ColorLabel.Color:= clWhite
      else if ITabColorDlg.R4.Checked then ColorLabel.Color:= clBtnFace
      else if ITabColorDlg.R5.Checked then ColorLabel.Color:= clBtnShadow
      else if ITabColorDlg.R6.Checked then ColorLabel.Color:= clBtnHighLight
      else ColorLabel.Color:= clScrollbar;
    end;
  Finally
    ITabColorDlg.Free;
  end;
end;

procedure TITabExptMainForm.DatBttnClick(Sender: TObject);
begin
  LwSetup := TLw_Setup.Create(Self);
  try
    if LwSetup.ShowModal = mrOk then begin
      TableDirEdit.Text:= __Laufwerk;
    end;
  finally
    LwSetup.Free;
  end;
end;

procedure TITabExptMainForm.SpeedButton2Click(Sender: TObject);
var Klar: Boolean;
    Nam : ShortString;
begin
  Klar:= False;
  if srceTable.Active then srceTable.Close;
  ITabDefDlg:= TITabDefDlg.Create(Self);
  try
    While Pos('\',DateiName) > 0 do Delete(DateiName,1,Pos('\',DateiName));
    if Pos('.',DateiName) > 0 then DateiName:= Copy(DateiName,1,Pos('.',DateiName)-1);
    ITabDefDlg.TblName:= DateiName;
    if DateiName <> '' then begin
      Nam:= TableDirEdit.Text + '\' + DateiName+'.DEF';
      While Pos('\\',Nam) > 0 do Delete(Nam,Pos('\\',Nam),1);
      ITabDefDlg.Lade(Nam);
    end;
    if ITabDefDlg.ShowModal = idOK then Klar:= True
    else Klar:= False;
  finally
    ITabDefDlg.Free;
  end;
  if Klar then begin
    if DateiName <> '' then begin
      srceTable.Structure:= DateiName+'.DEF';
      srceTable.Open;
    end;
    Listbox1.Items.Clear;
    Listbox2.Items.Clear;
    srceTable.GetFieldNames(Listbox1.Items);
    srceTable.GetIndexList(Listbox2.Items);
  end;
end;

procedure TITabExptMainForm.PxStruBttnClick(Sender: TObject);
begin
  StruktDialog:= TStruktDialog.Create(Self);
  Try
    StruktDialog.ShowModal;
  Finally
    StruktDialog.Free;
  End;
end;

end.
