unit Itabsuch;
{copyright 1995,1996,1997 by Stellberg Computer GmbH}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Itabbrow, Fvcbrows, Itblctrl,
  Itable, Filer;

type
  TITabSuchDlg = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Bevel1: TBevel;
    IsamHeader1: TIsamHeader;
    SuchBrowser1: TITabBrowser;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ITable1: TITable;
    IsamDataSource1: TIsamDataSource;
    ISAMKeyCtrl1: TISAMKeyCtrl;
    ItabNavigator1: TItabNavigator;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SuchBrowser1DblClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

Function ITabSuche(Table: TIDataSet; Parent: TForm; var Ref: Longint; var Key: IsamKeyStr): Boolean;

var
  ITabSuchDlg: TITabSuchDlg;

implementation

Uses ITabTool;

{$R *.DFM}

procedure TITabSuchDlg.FormCreate(Sender: TObject);
begin
  if Sprache = 1 then begin
    Caption:= 'Search';
    Label2.Caption:= 'KEY';
    Label1.Caption:= 'search for';
  end;
end;

procedure TITabSuchDlg.Edit1Change(Sender: TObject);
begin
  SuchBrowser1.LowKey:= String_Ansi2Oem(ITable1.AnsiConvert,Edit1.Text);
end;

procedure TITabSuchDlg.BitBtn1Click(Sender: TObject);
var Ref: Longint;
begin
  ITable1.RecNo:= SuchBrowser1.GetCurrentDatRef;
  ITable1.Satzlesen(Ref);
  ModalResult:= mrOk;
end;

Function ITabSuche(Table: TIDataSet; Parent: TForm; var Ref: Longint; var Key: IsamKeyStr): Boolean;
begin
  Ref:= 0;
  Key:= '';
  Result:= False;
  ITabSuchDlg:= TITabSuchDlg.Create(Parent);
  Try
    ItabSuchDlg.ITable1:= TITable(Table);
    ITabSuchDlg.IsamDataSource1.DataSet:= Table;
    ITabSuchDlg.SuchBrowser1.KeyNumber:= Table.KeyNo;
    if ItabSuchDlg.ShowModal = mrOk then begin
      Ref:= ItabSuchDlg.ITable1.RecNo;
      Key:= ItabSuchDlg.ITable1.KeyStr;
      Result:= True;
    end;        
  Finally
    ItabSuchDlg.Free;
  end;
end;

procedure TITabSuchDlg.FormShow(Sender: TObject);
begin
  SuchBrowser1.SetandUpdateBrowserScreen('',0);
end;

procedure TITabSuchDlg.SuchBrowser1DblClick(Sender: TObject);
begin
  BitBtn1Click(Sender);
end;

end.
