unit ItabWait;
{copyright 1995,1996,1997 by Stellberg Computer GmbH}
interface
 
uses Forms, Controls, StdCtrls, Buttons, ExtCtrls, Classes;

{$IFnDEF VER90}
Type
  ShortString = String; 
{$Endif}
type
  TWaitDlg = class(TForm)
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    Image2: TImage;
    procedure FormCreate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    Procedure Zeige(S: Shortstring);
  end;

var
  WaitDlg: TWaitDlg;

implementation

Uses ITblCons, ITabtool, ItabDat,
{$IFDEF VER90}
     Windows;
{$ELSE}
     WinTypes, Graphics;
{$ENDIF}
{$R *.DFM}
    
Procedure TWaitDlg.Zeige(S: Shortstring);
var PaintRect: TRect;
    x,y: Integer;
    S1: Shortstring;
begin
  PaintRect:= Image2.ClientRect;
  with Image2.Canvas do begin
    Brush.Style := bsClear;
    Font := Self.Font;
    Font.Color := clBlack;
    Image2.Canvas.Brush.Color := clWindow;
    Image2.Canvas.FillRect(Image2.ClientRect);
    Y:= -5;
    Repeat
      S1:= S;
      if Pos(#13,S1) > 0 then begin
        S1:= Copy(S,1,Pos(#13,S)-1);
        Delete(S,1,Pos(#13,S));
      end
      else S:= '';
      with PaintRect do begin
        X := (Right - Left + 1 - TextWidth(S1)) div 2;
        Y := Y + TextHeight(S1)+5;
      end;
      Image2.Canvas.TextOut(X, Y, S1);
    Until (S = '') or (Y > PaintRect.Bottom);
  end;
end;

procedure TWaitDlg.FormCreate(Sender: TObject);
begin
  CancelBtn.Caption:= GetMess(102);
  Caption:= GetMess(111);
end;

procedure TWaitDlg.CancelBtnClick(Sender: TObject);
begin
   If Password(_Pw) then begin
     CloseWait;
     Halt(11);
   end;
end;

end.
