unit Itexedit;

interface

Uses Classes, DB, DbTables, Graphics, Forms;
{$I DEFINE.PAS}
function Erzeuge_EditorSource(Parent: TForm;
                              const UnitIdent, FormIdent, SrcUnitIdent,
                              ProtoName: string;
                              SrcTable, AltCodeTable: TTable;
                              alsMainform,
                              AutoInc, NormInputs: Boolean;
                              dbTyp: Byte;
                              OrigPas: String): TMemoryStream;

implementation

Uses SysUtils, UToolDll, Bde_Base, Dialogs, Bde_Code, Bde_Expt;

const CRLF = #13#10;

function Erzeuge_EditorSource(Parent: TForm;
                              const UnitIdent, FormIdent, SrcUnitIdent,
                              ProtoName: string;
                              SrcTable, AltCodeTable: TTable;
                              alsMainform,
                              AutoInc, NormInputs: Boolean;
                              dbTyp: Byte;
                              OrigPas: String): TMemoryStream;
Var Exp: TBdeMainForm;
    I: integer;
    F: TField;
    G: Byte;
    TName: String;
    DBExt, DBExt2: String[10];
    NStr : String;
    DbFeldList: TStringList;
    DbFldNam  : String;
    SrcCode   : TStringList;
    TempSrc   : TStringList;
    Zeile,idx : Integer;
    SStr,GStr : String;
    Ignorieren, Impl: Boolean;
    PS: Array[0..255] of Char;

  Procedure Einfuegen(var S: String; CodeNr,x1Pos: Integer);
  var i,NavNr: Integer;
  begin
    Delete(S,x1Pos,4);
    Case CodeNr of
      1 : Insert(UnitIdent, S, x1Pos);
      2 : Insert(FormIdent, S, x1Pos);
      5 : Insert(SrcUnitIdent, S, x1Pos);
      10: if SrcTable.FieldCount > 0 then begin
            For i:= 0 to SrcTable.FieldCount-1 do begin
              if (I > 0) or (AutoInc = False) then begin
                F:= SrcTable.Fields[i];
                G:= GetFieldTypEditor(F);
                if NormInputs then begin
                {$IFDEF NEWINPUTS}
                  Case G of
                    1: begin
                         TempSrc.Add('    '+F.FieldName+'Input: TDateEdit;');
                         TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    2: begin
                          TempSrc.Add('    '+F.FieldName+'Input: TNumEdit;');
                          TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    3: begin
                         TempSrc.Add('    '+F.FieldName+'Input: TMemo;');
                         TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    4: begin
                          TempSrc.Add('    '+F.FieldName+'Input: TRadioGroup;');
                          TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    else begin
                      TempSrc.Add('    '+F.FieldName+'Input: TStrEdit;');
                      TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                    end;
                  end;
                  {$ELSE}
                  Case G of
                    1: begin
                         TempSrc.Add('    '+F.FieldName+'Input: TEdit;');
                         TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    2: begin
                         TempSrc.Add('    '+F.FieldName+'Input: TEdit;');
                         TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    3: begin
                         TempSrc.Add('    '+F.FieldName+'Input: TMemo;');
                         TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    4: begin
                         TempSrc.Add('    '+F.FieldName+'Input: TRadioGroup;');
                         TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                       end;
                    else begin
                         TempSrc.Add('    '+F.FieldName+'Input: TEdit;');
                         TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                    end;
                  end;
                  {$ENDIF}
                end
                else begin
                  if G = 3 then begin
                    TempSrc.Add('    '+F.FieldName+'Input: TDbMemo;');
                    TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                  end
                  else if G = 4 then begin
                    TempSrc.Add('    '+F.FieldName+'Input: TDbRadioGroup;');
                    TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                  end
                  else begin
                    TempSrc.Add('    '+F.FieldName+'Input: TDbEdit;');
                    TempSrc.Add('    '+F.FieldName+'Label: TLabel;');
                  end;
                end;
              end;
            end;
            S:= '*';
          end;

      11: begin
           {$IFDEF NEWINPUTS}
            if NormInputs then begin
              Insert('DateEdit, NumCtrl,',S, x1Pos);
            end;
           {$ENDIF}
          end;
      12: begin
            S:= '*';
            {$IFDEF NEWINPUTS}
            TempSrc.Add('      end');
            TempSrc.Add('      else if (Components[i] is TDateEdit) then begin');
            TempSrc.Add('        if TDateEdit(Components[i]).Modified then M:= True;');
            TempSrc.Add('      end');
            TempSrc.Add('      else if (Components[i] is TNumEdit) then begin');
            TempSrc.Add('        if TNumEdit(Components[i]).Modified then M:= True;');
            TempSrc.Add('      end');
            TempSrc.Add('      else if (Components[i] is TStrEdit) then begin');
            TempSrc.Add('        if TStrEdit(Components[i]).Modified then M:= True;');
            {$ENDIF}
          end;
      13: begin
            S:= '*';
            {$IFDEF NEWINPUTS}
            TempSrc.Add('      end');
            TempSrc.Add('      else if (Components[i] is TDateEdit) then begin');
            TempSrc.Add('        TDateEdit(Components[i]).Modified := False;');
            TempSrc.Add('      end');
            TempSrc.Add('      else if (Components[i] is TNumEdit) then begin');
            TempSrc.Add('        TNumEdit(Components[i]).Modified := False;');
            TempSrc.Add('      end');
            TempSrc.Add('      else if (Components[i] is TStrEdit) then begin');
            TempSrc.Add('        TStrEdit(Components[i]).Modified := False;');
            {$ENDIF}
          end;
      14: begin
            S:= '*';
            if SrcTable.FieldCount > 0 then begin
              For i:= 0 to SrcTable.FieldCount-1 do begin
                if (I > 0) or (AutoInc = False) then begin
                  F:= SrcTable.Fields[i];
                 {$IFDEF NEWINPUTS}
                  case F.DataType of
                    ftSmallInt: begin
                                  TempSrc.Add('  '+F.FieldName+'Input.Value:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                              F.FieldName+chr(39)+').AsInteger;');
                                end;
                    ftInteger : begin
                                  TempSrc.Add('  '+F.FieldName+'Input.Value:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                              F.FieldName+chr(39)+').AsLongInt;');
                                end;
                    ftWord    : begin
                                  TempSrc.Add('  '+F.FieldName+'Input.Value:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                              F.FieldName+chr(39)+').AsLongInt;');
                                end;
                    ftFloat   : begin
                                  TempSrc.Add('  '+F.FieldName+'Input.Value:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                              F.FieldName+chr(39)+').AsFloat;');
                                end;
                    ftBoolean : begin
                                  TempSrc.Add('  if '+FormIdent+'Table.FieldByName('+Chr(39)+
                                              F.FieldName+chr(39)+').AsBoolean = True then '+
                                              F.FieldName+'Input.ItemIndex:= 1');
                                  TempSrc.Add('  else '+F.FieldName+'Input.ItemIndex:= 0;');
                                end;
                    ftMemo,
                    ftBlob    : begin
                                  TempSrc.Add('  '+F.FieldName+'Input.Lines.Assign(TMemoField('+FormIdent+'Table.FieldByName('+
                                   Chr(39)+ F.FieldName+chr(39)+')));');
                                end;
                    else TempSrc.Add('  '+F.FieldName+'Input.Text:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                              F.FieldName+chr(39)+').AsString;');
                  end;
                  {$ELSE}
                  case F.DataType of
                    ftSmallInt: TempSrc.Add('  '+F.FieldName+'Input.Text:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString;');
                    ftInteger : TempSrc.Add('  '+F.FieldName+'Input.Text:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString;');
                    ftWord    : TempSrc.Add('  '+F.FieldName+'Input.Text:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString;');
                    ftFloat   : TempSrc.Add('  '+F.FieldName+'Input.Text:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString;');
                    ftDate    : TempSrc.Add('  '+F.FieldName+'Input.Text:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString;');
                    ftBoolean : begin
                                  TempSrc.Add('  if '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsBoolean = True then '+F.FieldName+'Input.ItemIndex:= 1');
                                  TempSrc.Add('  else '+F.FieldName+'Input.ItemIndex:= 0;');
                                end;
                    ftMemo,
                    ftBlob    : TempSrc.Add('  '+F.FieldName+'Input.Lines.Assign(TMemoField('+FormIdent+'Table.FieldByName('+
                                Chr(39)+ F.FieldName+chr(39)+');');
                    else TempSrc.Add('  '+F.FieldName+'Input.Text:= '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString;');
                  end;
                  {$ENDIF}
                end;
              end;
            end;
          end;
      15: begin
            S:= '*';
            if SrcTable.FieldCount > 0 then begin
              For i:= 0 to SrcTable.FieldCount-1 do begin
                if (I > 0) or (AutoInc = False) then begin
                  F:= SrcTable.Fields[i];
                  {$IFDEF NEWINPUTS}
                  Case F.DataType of
                    ftSmallInt: TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsInteger:= StrInt('+F.FieldName+'Input.Text);');
                    ftInteger : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsLongint:= StrInt('+F.FieldName+'Input.Text);');
                    ftWord    : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsInteger:= StrInt('+F.FieldName+'Input.Text);');
                    ftFloat   : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsFloat:= StrDez('+F.FieldName+'Input.Text);');
                    ftBoolean : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsBoolean:= ('+F.FieldName+'Input.ItemIndex = 1);');
                    ftMemo,
                    ftBlob    : TempSrc.Add('  TMemoField('+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+')).Assign('+F.FieldName+'Input.Lines);');
                    else TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString:= '+F.FieldName+'Input.Text;');
                  end;
                  {$ELSE}
                  Case F.DataType of
                    ftSmallInt: TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString:= '+F.FieldName+'Input.Text;');
                    ftInteger : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString:= '+F.FieldName+'Input.Text;');
                    ftWord    : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString:= '+F.FieldName+'Input.Text;');
                    ftFloat   : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString:= '+F.FieldName+'Input.Text;');
                    ftBoolean : TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsBoolean:= ('+F.FieldName+'Input.ItemIndex = 1);');
                    ftMemo,
                    ftBlob    : TempSrc.Add('   TMemoField('+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+')).Assign('+F.FieldName+'Input.Lines);');
                    else TempSrc.Add('  '+FormIdent+'Table.FieldByName('+Chr(39)+
                                           F.FieldName+chr(39)+').AsString:= '+F.FieldName+'Input.Text;');
                  end;
                  {$ENDIF}
                end;
              end;
            end;
          end;
      16: begin
            S:= '*';
            if SrcTable.FieldCount > 0 then begin
              For i:= 0 to SrcTable.FieldCount-1 do begin
                if (I > 0) or (AutoInc = False) then begin
                  F:= SrcTable.Fields[i];
                  {$IFDEF NEWINPUTS}
                  Case F.DataType of
                    ftSmallInt: TempSrc.Add('  '+F.FieldName+'Input.Value:= 0;');
                    ftInteger,
                    ftWord    : TempSrc.Add('  '+F.FieldName+'Input.Value:= 0;');
                    ftFloat   : TempSrc.Add('  '+F.FieldName+'Input.Value:= 0;');
                    ftBoolean : TempSrc.Add('  '+F.FieldName+'Input.ItemIndex:= 0;');
                    ftMemo,
                    ftBlob    : TempSrc.Add('  '+F.FieldName+'Input.Lines.Clear;');
                    else TempSrc.Add('  '+F.FieldName+'Input.Text:= '+Chr(39)+Chr(39)+';');
                  end;
                  {$ELSE}
                  Case F.DataType of
                    ftSmallInt: TempSrc.Add('  '+F.FieldName+'Input.Text:= '+Chr(39)+'0'+Chr(39)+';');
                    ftInteger,
                    ftWord    : TempSrc.Add('  '+F.FieldName+'Input.Text:= '+Chr(39)+'0'+Chr(39)+';');
                    ftFloat   : TempSrc.Add('  '+F.FieldName+'Input.Text:= '+Chr(39)+'0.00'+Chr(39)+';');
                    ftBoolean : TempSrc.Add('  '+F.FieldName+'Input.ItemIndex:= 0;');
                    ftMemo,
                    ftBlob    : TempSrc.Add('  '+F.FieldName+'Input.Lines.Clear;');
                    else TempSrc.Add('  '+F.FieldName+'Input.Text:= '+Chr(39)+Chr(39)+';');
                  end;
                  {$ENDIF}
                end;
              end;
            end;
          end;
      17: Insert(TName+DBExt, S, x1Pos);
      18: Insert(TName+DBExt2,S, x1Pos);
      19: begin
            S:= '*';
            if SrcTable.FieldCount > 0 then begin
              DbFeldList:= TStringList.Create;
              For i:= 0 to SrcTable.FieldCount-1 do begin
                if (I > 0) or (AutoInc = False) then begin
                  F:= SrcTable.Fields[i];
                  DbFldNam:= GetDbaseFeldName(DBFeldList,F.FieldName,'D');
                  {$IFDEF NEWINPUTS}
                  Case F.DataType of
                    ftSmallInt: TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsInteger:= StrInt('+
                                        F.FieldName+'Input.Text);');
                    ftInteger : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsLongInt:= StrInt('+
                                            F.FieldName+'Input.Text);');
                    ftWord    : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsInteger:= StrInt('+
                                            F.FieldName+'Input.Text);');
                    ftFloat   : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsFloat:= StrDez('+
                                           F.FieldName+'Input.Text);');
                    ftBoolean : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsBoolean:= ('+
                                           F.FieldName+'Input.ItemIndex = 1);');
                    ftMemo,
                    ftBlob    : TempSrc.Add('  TMemoField(EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+')).Assign('+
                                           F.FieldName+'Input.Lines);');
                    else TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsString:= '+
                                            F.FieldName+'Input.Text;');
                  end;
                  {$ELSE}
                  Case F.DataType of
                    ftSmallInt: TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsString:= '+
                                            F.FieldName+'Input.Text;');
                    ftInteger : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsString:= '+
                                            F.FieldName+'Input.Text;');
                    ftWord    : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsString:= '+
                                            F.FieldName+'Input.Text;');
                    ftFloat   : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsString:= '+
                                            F.FieldName+'Input.Text;');
                    ftBoolean : TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsBoolean:= ('+
                                            F.FieldName+'Input.ItemIndex = 1);');
                    ftMemo,
                    ftBlob    : TempSrc.Add('  TMemoField(EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+')).Assign('+
                                            F.FieldName+'Input.Lines);');
                    else TempSrc.Add('  EinzelTable.FieldByName('+Chr(39)+DbFldNam+Chr(39)+').AsString:= '+
                                            F.FieldName+'Input.Text;');
                  end;
                  {$ENDIF}
                end;
              end;
              DbFeldList.Free;
            end;
          end;
      20: if NormInputs then begin
            (* TempSrc.Add('    AnlegBttn  : TSpeedButton;');
            TempSrc.Add('    AendernBttn: TSpeedButton;'); *)
            S:= '*';
          end;
      21: begin
            if NormInputs then begin
              TempSrc.Add('    Function IsModified: Boolean;');
              TempSrc.Add('    Procedure ResetModified;');
              TempSrc.Add('  Public');
              TempSrc.Add('    Procedure SetData;');
              TempSrc.Add('    Procedure LeerData;');
              TempSrc.Add('    Procedure GetData;');
            end
            else TempSrc.Add('    InsertMode: Boolean;');
            S:= '*';
          end;
      22: if NormInputs = False then Insert('NormInputs:= False;', S, x1Pos);
      23: begin
            S:= '*';
            (* if NormInputs then begin
              TempSrc.Add('Procedure AendernBttnClick(Sender: TObject);');
              TempSrc.Add('Procedure AnlegBttnClick(Sender: TObject);');
            end; *)
          end;
      51: begin
            NavNr:= GetNavNr(Exp.ToolNavigator1, Exp.ToolNavigator2,Copy(S,x1Pos,Length(S)-x1Pos+1));
            if NavNr = 0 then begin
              S:= '*';
              Ignorieren:= True;
            end
            else Insert(DezStr(NavNr),S,x1Pos);
          end;

    end;
  end;

  Procedure Auswerten(S: String);
  var xStr: String;
      x1Pos, x2Pos, CodeNr, Code: Integer;
      PS  : Array[0..255] of Char;
  begin
    xStr:= S;
    CodeNr:= 0;
    x1Pos:= Pos('%',xStr);
    if x1Pos > 0 then begin
      While x1Pos > 0 do begin
        Delete(xStr,1,x1Pos);
        x2Pos:= Pos('%',xStr);
        if x2Pos > 0 then begin
          xStr:= Copy(xStr,1,x2Pos-1);
          Val(xStr,CodeNr,Code);
        end;
        if CodeNr > 0 then Einfuegen(S,CodeNr,x1Pos);
        xStr:= S;
        CodeNr:= 0;
        x1Pos:= Pos('%',xStr);
      end;
    end;
    if S <> '*' then begin
      TempSrc.Add(S);
    end;
  end;

begin
  Exp:= TBdeMainForm(Parent);
  TName:= SrcTable.TableName;
  DBExt:= UpperCase(ExtractFileExt(TName));
  if DBExt = '.DB' then DBExt:= '_PDX' else DBExt:= '_DBF';
  if dbTyp = DBASE_ONLY then DBExt:= '_';
  While Pos('\',TName) > 0 do Delete(TName,1,Pos('\',TName));
  if Pos('.',TName) > 0 then TName:= Copy(TName,1,Pos('.',TName)-1);
  if dbTyp = DBASE_ONLY then DbExt2:= '_' else DbExt2:= '_DBF';
  TempSrc:= TStringList.Create;
  SrcCode:= TStringList.Create;
  SrcCode.LoadFromFile(ProtoName);
  if SrcCode.Count = 0 then MessageDlg(ProtoName+' konnte nicht geladen werden', mtError, [mbOk], 0)
  else begin
    Zeile:= 0;
    Ignorieren:= False;
    Impl:= False;
    Repeat
      SStr:= SrcCode[Zeile];
      GStr:= UpperCase(SStr);
      if Pos('IMPLEMENTATION',GStr) > 0 then Impl:= True;
      if ((Pos('FUNCTION',GStr) > 0) or (Pos('PROCEDURE',GStr) > 0)
      or (Pos('END.',GStr) > 0)) then begin
        if NormInputs = False then begin
          if ((Pos('.RESETMODIFIED',GStr) > 0) or (Pos('.GETDATA',GStr) > 0)
          or (Pos('.SETDATA',GStr) > 0) or (Pos('.LEERDATA',GStr) > 0)
          or (Pos('.ISMODIFIED',GStr) > 0)) then Ignorieren:= True
          else Ignorieren:= False;
        end
        else Ignorieren:= False;
      (* if (Impl) and (OrigPas <> '') and (Ignorieren = False) then begin
      {neu, damit nur die selektierten Procs upgedatet werden}
        if ((Pos('FUNCTION',GStr) > 0) or (Pos('PROCEDURE',GStr) > 0)) then begin
          Idx:= UpdList.Items.IndexOf(GetProcName(GStr));
          if (Idx < 0) or (UpdList.Selected[idx] = False) then Ignorieren:= True
          else Ignorieren:= False;
        end; *)
      end;
      if Ignorieren = False then Auswerten(SStr);
      if Impl = False then Ignorieren:= False;
      if Pos('END.',GStr) > 0 then Impl:= False;
      Inc(Zeile);
    Until Zeile = SrcCode.Count;
    if OrigPas <> '' then begin
      if Exp.EdiProcUpdcheck.Checked then Proc_Update(TempSrc,OrigPas,Exp.ListBox4)
      else AltSource_Verwerten(TempSrc,OrigPas,AltCodeTable);
    end;
    SourceBuffer := StrAlloc(SourceBufferSize);
    try
      Result := TMemoryStream.Create;
      try
        if TempSrc.Count > 0 then begin
          For i:= 0 to TempSrc.Count-1 do begin
            SStr:= TempSrc[i];
            Strpcopy(Ps,SStr+CRLF);
            FmtWrite(Result,PS,[NIL]);
          end;
        end;
        Result.Position := 0;
      except
        Result.Free;
        raise;
      end;
    finally
    StrDispose(SourceBuffer);
    end;
  end;
  TempSrc.Free;
  SrcCode.Free;
end;

end.
