unit Itesbrow;
 
interface
Uses Classes, DB, DbTables, Forms, ITable;

function Erzeuge_BrowserSource(Parent: TForm;
                               const UnitIdent, FormIdent,
                               EditUnitIdent,EditFormIdent,
                               ProtoName: Shortstring;
                               SrcTable: TITable;
                               AltCodeTable: TTable;
                               alsMainform, NormalInputs,
                               CreaBttn,ReorgBttn,
                               ExcelBttn,DBasBttn,PrtBttn,
                               Mit_EditDialog: Boolean;
                               OrigPas: ShortString): TMemoryStream;

implementation

Uses SysUtils, ITabTool, ITexBase, Dialogs, ITexCode,
     ITabExpt;

const
  CRLF = #13#10;

function Erzeuge_BrowserSource(Parent: TForm;
                               const UnitIdent, FormIdent,
                               EditUnitIdent,EditFormIdent,
                               ProtoName: Shortstring;
                               SrcTable: TITable;
                               AltCodeTable: TTable;
                               alsMainform, NormalInputs,
                               CreaBttn,ReorgBttn,
                               ExcelBttn,DBasBttn,PrtBttn,
                               Mit_EditDialog: Boolean;
                               OrigPas: ShortString): TMemoryStream;
Var Exp: TItabExptMainForm;
    TName, TblName : ShortString;
    DbExt,DbExt2   : String[10];
    TVollName      : ShortString;
    NStr,SStr,GStr : ShortString;
    SrcCode,TempSrc: TStringList;
    Zeile,i,idx    : Integer;
    Ignorieren,Impl: Boolean;
    PS: Array[0..255] of Char;

  Procedure Einfuegen(var S: ShortString; CodeNr,x1Pos: Integer);
  var i: Integer;
      F: TIsamField;
      NavNr: Integer;
  begin
    Delete(S,x1Pos,4);
    Case CodeNr of
      2 : Insert(EditFormIdent, S, x1Pos);
      3 : Insert(UnitIdent, S, x1Pos);
      4 : Insert(FormIdent, S, x1Pos);
      5 : Insert(TName,S,x1Pos);
      6 : begin
            if ExcelBttn then Insert('ITABEXCL,',S,x1Pos);
            if (DBasBttn) or (PrtBttn) then Insert('ITABDBAS,',S,x1Pos);
          end;
      50: begin {CREATEBTTN, DBASEBTTN ...}
            S:= '*';
            if CreaBttn then TempSrc.Add('    CreateButton: TSpeedButton;');
            if ReorgBttn then TempSrc.Add('    ReorgButton: TSpeedButton;');
            if ExcelBttn then begin
              TempSrc.Add('    ExcelExportBttn: TSpeedButton;');
              TempSrc.Add('    ExcelExportCtrl1: ExcelExportCtrl;');
            end;
            if DBasBttn then TempSrc.Add('    DBaseExportBttn: TSpeedButton;');
            if PrtBttn then TempSrc.Add('    PrintBttn: TSpeedButton;');
            if (DBasBttn) or (PrtBttn) then begin
              TempSrc.Add('    DBaseExportCtrl1: DBaseExportCtrl;');
            end;
          end;
      52: begin
            S:= '*';
            if CreaBttn then TempSrc.Add('    Procedure CreateButtonClick(Sender: TObject);');
            if ReorgBttn then TempSrc.Add('    Procedure ReorgButtonClick(Sender: TObject);');
            if ExcelBttn then TempSrc.Add('    Procedure ExcelExportBttnClick(Sender: TObject);');
            if DBasBttn then TempSrc.Add('    Procedure DBaseExportBttnClick(Sender: TObject);');
            if PrtBttn then TempSrc.Add('    Procedure PrintBttnClick(Sender: TObject);');
          end;
      53: begin
            if Mit_EditDialog then Insert(' '+EditUnitIdent,S,x1Pos)
            else Insert(' ITABTOOL',S,x1Pos);
          end;
      62: if alsMainForm then Insert('Close',S,x1Pos)
          else Insert('ModalResult:= mrCancel',S,x1Pos);
    end; {case}
  end;

  Procedure Auswerten(S: ShortString);
  var xStr: ShortString;
      x1Pos, x2Pos, CodeNr, Code: Integer;
      PS  : Array[0..255] of Char;
  begin
    xStr:= S;
    CodeNr:= 0;
    x1Pos:= Pos('%',xStr);
    if x1Pos > 0 then begin
      While x1Pos > 0 do begin
        Delete(xStr,1,x1Pos);
        x2Pos:= Pos('%',xStr);
        if x2Pos > 0 then begin
          xStr:= Copy(xStr,1,x2Pos-1);
          Val(xStr,CodeNr,Code);
        end;
        if CodeNr > 0 then Einfuegen(S,CodeNr,x1Pos);
        xStr:= S;
        CodeNr:= 0;
        x1Pos:= Pos('%',xStr);
      end;
    end;
    if S <> '*' then begin
      {StrPCopy(PS,S+CRLF);
      FmtWrite(Result,PS,[NIL]);}
      TempSrc.Add(S);
    end;
  end;

begin
  Exp:= TITabExptMainForm(Parent);
  TName:= SrcTable.TableName;
  NStr:= SrcTable.TableName;
  While Pos('\',NStr) > 0 do Delete(NStr,1,Pos('\',NStr));
  TblName:= NStr;
  DBExt:= Uppercase(ExtractFileExt(TName));
  DBExt:= '_DBF';
  DBExt2:= '_PDX';
  While Pos('\',TName) > 0 do Delete(TName,1,Pos('\',TName));
  TVollName:= TName;
  if Pos('.',TName) > 0 then TName:= Copy(TName,1,Pos('.',TName)-1);
  TempSrc:= TStringList.Create;
  SrcCode:= TStringList.Create;
  SrcCode.LoadFromFile(ProtoName);
  if SrcCode.Count = 0 then MessageDlg(ProtoName+' konnte nicht geladen werden', mtError, [mbOk], 0)
  else begin
    Zeile:= 0;
    Ignorieren:= False;
    Impl:= False;
    Repeat
      SStr:= SrcCode[Zeile];
      GStr:= UpperCase(SStr);
      if Pos('IMPLEMENTATION',GStr) > 0 then Impl:= True;
      if ((Pos('FUNCTION',GStr) > 0) or (Pos('PROCEDURE',GStr) > 0)
      or ( Pos('TSPEEDBUTTON',GStr) > 0)
      or ( Pos('END.',GStr) > 0)) then begin
        if ((ReorgBttn = False) and (Pos('.REORGBUTTONCLICK',GStr) > 0))
        or ((CreaBttn = False) and (Pos('.CREATEBUTTONCLICK',GStr) > 0))
        or ((ExcelBttn = False) and (Pos('.EXCELEXPORTBTTNCLICK',GStr) > 0))
        or ((DBasBttn = False) and (Pos('.DBASEEXPORTBTTNCLICK',GStr) > 0))
        or ((PrtBttn = False) and (Pos('.PRINTBTTNCLICK',GStr) > 0))
        then Ignorieren:= True
        else Ignorieren:= False;
      end;
      if Ignorieren = False then Auswerten(SStr);
      if Impl = False then Ignorieren:= False;
      if Pos('END.',GStr) > 0 then begin
        Impl:= False;
        Ignorieren:= False;
      end;
      Inc(Zeile);
    Until Zeile = SrcCode.Count;
    if OrigPas <> '' then begin
      if Exp.BrwProcUpdcheck.Checked then Proc_Update(TempSrc,OrigPas,Exp.ListBox3)
      else AltSource_Verwerten(TempSrc,OrigPas,AltCodeTable);
    end;
    SourceBuffer := StrAlloc(SourceBufferSize);
    try
      Result := TMemoryStream.Create;
      try
        if TempSrc.Count > 0 then begin
          For i:= 0 to TempSrc.Count-1 do begin
            SStr:= TempSrc[i];
            Strpcopy(Ps,SStr+CRLF);
            FmtWrite(Result,PS,[NIL]);
          end;
        end;
        Result.Position := 0;
      except
        Result.Free;
        raise;
      end;
    finally
      StrDispose(SourceBuffer);
    end;
  end;
  TempSrc.Free;
  SrcCode.Free;
end;

end.
