{1  EditUnitName
 2  EditFormName
 3  BrwUnitName
 4  BrwFormName
 5  StruUnitName
 10 InputDeklarationen (TEDIT, TLABEL ...)
 11 Interface-Uses (abhngig von Norminputs ..)
 12 Modified-Einfgungen (abhngig von NormInputs ..)
 13 RstModified-Einfgungen (abhngig von NormInputs ..)
 14 SetData-Einfgungen
 15 GetData-Einfgungen
 16 LeerData-Einfgungen
 17 Original-Struktur (PDX oder DBF)
 18 DBF-Struktur (fr Druck)
 19 EinzelTable.FieldbyName()... (fr Druck-Export)
 20 Aendernbttn und AnlegBttn nur bei Norminputs
 21 Private und Public-Funktion nur bei Norminputs
 22 Ergnzung bei FormCreate (nur bei DbEdits)
 23 AendernbttnClick und AnlegBttnclick (nur fr Norminputs) definieren

 50 Feld-Deklarationen beim Browser
 51 Bttn-Deklarationen
 52 BttnOnClick-Deklarationen
 53 Implementation-Uses-Anweisungen
 54 Alias einfuegen
 55 TableName
 56 xxx_PDX, xxx_DBF, xxx_ (Strukturnamen)
 57 xxx_DBF (StrukturName fr Druck-Export)
 58 xxx_DBF (fuer Export, Import)
 59 voller Tabellenname
 60 DBF hinter Strukturname von Druck-Export
 61 DBExt2 fr Export
 62 Modalresult oder Close
 63 SetData fr Norminputs
 64 
 65 LeerData fr Norminputs (Neubttnclick)
 66

}


unit Itexbase;

interface
Uses Classes, ITable, ITblCtrl, Forms;

{$Ifndef Ver90}
Type
Shortstring = String;
{$Endif}

Const SourceBufferSize = 4096;

Const PARADOX_ONLY      = 1;
      DBASE_ONLY        = 2;
      PARADOX_UND_DBASE = 3;

var SourceBuffer: PChar;

Function GetFieldTypeName(F: TIsamField): Shortstring;
Function GetFieldTypEditor(F: TIsamField): Byte;
procedure FmtWrite(Stream: TStream; Fmt: PChar;
                   const Args: array of const);
Function GetDecimals(SrcTable: TITable; Fld: Integer): Integer;
Function GetDBaseFeldName(Liste: TStringList; Name: Shortstring; TypStr: Char): Shortstring;
Function STRIP(VAR S: Shortstring): Shortstring;
Function Space(SpZahl: Integer): Shortstring;
{Procedure CheckDlgMethods(T: TToolNavigator; Liste: TStringList;
                          TName: Shortstring; Rslt: TForm);
Function GetNavNr(TN1, TN2: TToolNavigator; S: Shortstring): Integer;}

implementation

Uses SysUtils,
     {$IFDEF VER90}
     BDE,
     {$ELSE}
     DbiTypes, DbiProcs,
     {$ENDIF}
     Proxies, ITblCons;

Function Space(SpZahl: Integer): Shortstring;
var S: Shortstring;
    x: Byte;
begin
  S:= '';
  if SpZahl > 0 then begin
    for x:= 1 to SpZahl do s:= s + ' ';
  end;
  Space:= S;
end;

Function STRIP(VAR S: Shortstring): Shortstring;
{ Nimmt einem Shortstring alle Leerzeichen }
VAR L1, L2 : Byte;
BEGIN
  L1:=1;
  WHILE ( L1 < Length(S) ) AND ( S[L1] IN [#9..#13, ' '] ) DO Inc(L1);
  L2:=Length(S);
  WHILE ( L2 > 0 ) AND ( S[L2] IN [#9..#13, ' '] ) DO Dec(L2);
  S:=Copy(S, L1, L2-L1+1);
  L1:= Pos(' ',S);
  While L1 > 0 do begin
    Delete(S,L1,1);
    L1:= Pos(' ',S);
  end;
  Strip:= S;
END; (* Strip *)

(* Function GetNavNr(TN1, TN2: TToolNavigator; S: Shortstring): Integer;
var xPos,Nr,N: Integer;
    Gefunden: Boolean;
begin
  S:= UpperCase(S);
  xPos:= Pos('CLICK',S);
  if xPos > 0 then Delete(S,xPos,xPos+4);
  xPos:= Pos('(',S);
  if xPos > 0 then S:= Copy(S,1,xPos-1);
  Nr:= 0;
  Gefunden:= False;
  if TN1 <> NIL then begin
    if TN1.VButtons.Count > 0 then begin
      N:= 0;
      Repeat
        if TN1.VButtons[N] = S then Gefunden:= True
        else inc(N);
      until (N = TN1.VButtons.Count-1) or (Gefunden);
      if TN1.VButtons[N] = S then Gefunden:= True;
      if Gefunden then Nr:= 1;
    end;
  end;
  if Gefunden = False then begin
    if TN2 <> NIL then begin
      if TN2.VButtons.Count > 0 then begin
        N:= 0;
        Repeat
          if TN2.VButtons[N] = S then Gefunden:= True
          else Inc(N);
        until (N = TN2.VButtons.Count-1) or (Gefunden);
        if TN2.VButtons[N] = S then Gefunden:= True;
        if Gefunden then Nr:= 2;
      end;
    end;
  end;
  Result:= Nr;
end;

Procedure CheckDlgMethods(T: TToolNavigator; Liste: TStringList;
                          TName: Shortstring; Rslt: TForm);
var i: Integer;
    NStr: Shortstring;
    Method: TMethod;

begin
  if Liste <> NIL then begin
    if Liste.Count > 0 then begin
      For i:= 0 to Liste.Count-1 do begin
        NStr:= Liste[i];
        if NStr = 'DATEIANFANG' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickDateiAnfang');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickDateiAnfang');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickDateiAnfang:= TNotifyEvent(Method);
        end
        else if NStr = 'ZURUECK' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickZurueck');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickZurueck');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickZurueck:= TNotifyEvent(Method);
        end
        else if NStr = 'VOR' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickVor');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickVor');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickVor:= TNotifyEvent(Method);
        end
        else if NStr = 'DATEIENDE' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickDateiEnde');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickDateiEnde');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickDateiEnde:= TNotifyEvent(Method);
        end
        else if NStr = 'LEER' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickLeer');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickLeer');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickLeer:= TNotifyEvent(Method);
        end
        else if NStr = 'EDIT' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickEdit');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickEdit');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickEdit:= TNotifyEvent(Method);
        end
        else if NStr = 'SUCHEN' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickSuchen');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickSuchen');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickSuchen:= TNotifyEvent(Method);
        end
        else if NStr = 'QBE' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickQBE');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickQBE');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickQBE:= TNotifyEvent(Method);
        end
        else if NStr = 'KEY' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickKey');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickKey');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickKey:= TNotifyEvent(Method);
        end
        else if NStr = 'DELETE' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickDelete');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickDelete');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickDelete:= TNotifyEvent(Method);
        end
        else if NStr = 'ANLEGEN' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickAnlegen');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickAnlegen');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickAnlegen:= TNotifyEvent(Method);
        end
        else if NStr = 'AENDERN' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickAendern');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickAendern');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickAendern:= TNotifyEvent(Method);
        end
        else if NStr = 'OK' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickOk');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickOk');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickOk:= TNotifyEvent(Method);
        end
        else if NStr = 'REORG' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickReorg');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickReorg');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickReorg:= TNotifyEvent(Method);
        end
        else if NStr = 'NEUETABELLE' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickNeueTabelle');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickNeueTabelle');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickNeueTabelle:= TNotifyEvent(Method);
        end
        else if NStr = 'DBEXPORT' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickDBExport');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickDBExport');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickDBExport:= TNotifyEvent(Method);
        end
        else if NStr = 'DBIMPORT' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickDBImport');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickDBImport');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickDBImport:= TNotifyEvent(Method);
        end
        else if NStr = 'EXCEL' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickExcel');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickExcel');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickEXCEL:= TNotifyEvent(Method);
        end
        else if NStr = 'WORD' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickWord');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickWord');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickWord:= TNotifyEvent(Method);
        end
        else if NStr = 'PRINT' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickPrint');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickPrint');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickPrint:= TNotifyEvent(Method);
        end
        else if NStr = 'DATSETUP' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickDatSetup');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickDatSetup');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickDatSetup:= TNotifyEvent(Method);
        end
        else if NStr = 'BROWSERSETUP' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickBrowserSetup');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickBrowserSetup');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickBrowserSetup:= TNotifyEvent(Method);
        end
        else if NStr = 'ZURUECK' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickAbout');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickAbout');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickAbout:= TNotifyEvent(Method);
        end
        else if NStr = 'HILFE' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickHilfe');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickHilfe');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickHilfe:= TNotifyEvent(Method);
        end
        else if NStr = 'QUIT' then begin
          {$IFDEF VER90}
          Method.Code:= CreateSubClassMethod(Rslt,TName+'ClickQuit');
          {$ELSE}
          Method.Code := TProxyForm(Rslt).CreateMethod(TName+'ClickQuit');
          {$ENDIF}
          Method.Data := Rslt;
          T.ClickQuit:= TNotifyEvent(Method);
        end;
      end;
    end;
  end;
end; *)

Function GetDBaseFeldName(Liste: TStringList; Name: Shortstring; TypStr: Char): Shortstring;
var DbFeldName, DbFldNam: Shortstring;
    fnx: Integer;
begin
  DBFeldName:= Name;
  if (TypStr = 'D') and (Length(DbFeldName) > 8) then DbFeldName:= Copy(DbFeldName,1,8);
  DbFldNam:= DbFeldName;
  if Liste.Indexof(DbFldNam) > -1 then begin
    fnx:= 1;
    Repeat
      inc(fnx);
      DbFldNam:= Copy(DbFeldName,1,6)+IntToStr(fnx);
    Until Liste.Indexof(DbFldNam) = -1;
  end;
  Liste.Add(DbFldNam);
  Result:= DbFldNam;
end;

Function GetFieldTypEditor(F: TIsamField): Byte;
var G: Byte;
begin
  if (F.Typ = ftDate) or (F.Typ = ftWordDate)
  then G:= 1
  else
  if (F.Typ = ftReal) or (F.Typ = ftInteger)
  or (F.Typ = ftWord) then G:= 2
  else
  if (F.Typ = ftMemo) then G:= 3
  else if (F.Typ = ftBoolean) then G:= 4
  else G:= 0;
  GetFieldTypEditor:= G;
end;

procedure FmtWrite(Stream: TStream; Fmt: PChar;
                   const Args: array of const);
begin
  if (Stream <> nil) and (SourceBuffer <> nil) then
  begin
    StrLFmt(SourceBuffer, SourceBufferSize, Fmt, Args);
    Stream.Write(SourceBuffer[0], StrLen(SourceBuffer));
  end;
end;

Function GetFieldTypeName(F: TIsamField): Shortstring;
var S: Shortstring;
begin
  S:= 'TIsamField';
  GetFieldTypeName:= S;
end;

Function GetDecimals(SrcTable: TITable; Fld: Integer): Integer;
begin
  Result:= SrcTable.FieldDec(Fld);
end;

end.
